package internal

import (
	"codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"
	"context"
	"fmt"
	"github.com/carlmjohnson/requests"
	"plugins/union_pay/internal/po"
)

// 插件通信信息,若不对应则会报错panic
const (
	Tag         = "union_pay"
	Version     = 1
	CookieKey   = "union_pay"
	CookieValue = "union_pay"
)

const (
	orderMethod    = "/upapi/mkt/cpn/couponAcquire/v1"
	orderBizMethod = "mkt.cpn.couponAcquire.v1"
)

const (
	queryMethod    = "/upapi/mkt/cpn/couponAcqQuery/v1"
	queryBizMethod = "mkt.cpn.couponAcqQuery.v1"
)

type UnionPayService struct{}

func (p *UnionPayService) Order(ctx context.Context, request *proto.OrderRequest) (*proto.OrderResponse, error) {
	conf, err := transformConfig(request.Config)
	if err != nil {
		return nil, err
	}
	uv := rechargeReq(request, conf.Extra.ChNlId)

	var response po.OrderResp
	url := fmt.Sprintf("%s%s", request.Config.BaseUri, orderMethod)
	err = requests.URL(url).Headers(headers(conf, uv, orderBizMethod)).BodyJSON(uv).ToJSON(&response).Fetch(ctx)
	if err != nil {
		return nil, fmt.Errorf("请求异常，msg:" + err.Error())
	}

	return rechargeResp(request, response), nil
}

func (p *UnionPayService) Query(ctx context.Context, request *proto.QueryRequest) (*proto.QueryResponse, error) {
	return nil, nil
}

func (p *UnionPayService) Notify(_ context.Context, request *proto.NotifyRequest) (*proto.NotifyResponse, error) {
	return nil, nil
}
